import es
import gamethread
import os
import cfglib
import playerlib
import weaponlib
import langlib
import usermsg
import spe

"""
Special THanks to:
- Ojii - For helping me :d
- Kamiqawa - Finnish Translation
- EMOtipsy.#sKratch - Norwegian Translation
- MMiaouw - French Translation
- TwistedVoid - Danish Translation
- Snipe! - Dutch Translation
- Freddukes - For his fade code :)

"""


info = es.AddonInfo()
info.author      = "Absolute"
info.name        = "Hide N Seek Source"
info.basename    = "hns"
info.version     = "2.1.0"
info.url         = "http://addons.eventscripts.com/addons/view/%s"%info.basename
info.description = "Hide N Seek for Counter-Strike Source" 

es.ServerVar("HnsVersion", info.version, info.description + " made by " + info.author).makepublic()

cfgpath = os.path.join( es.getAddonPath(info.basename), "config.cfg" )
if not os.path.isfile(cfgpath):
    es.dbgmsg(0,'ERROR: No config.cfg in %s found! Creating one now.' % es.getAddonPath(info.basename))

text = lambda identifier, options = {}, lang = "en" : "No strings.ini found in ../addons/eventscripts/%(basename)s/" % {"basename" : info.basename}

langPath = os.path.join( es.getAddonPath( info.basename ), "strings.ini" )
if os.path.isfile(langPath):
    text = langlib.Strings(langPath)
    
tags = str(es.ServerVar("sv_tags"))
if "hns" not in tags.split(","):
    es.ServerVar("sv_tags").set(tags + ",hns")

# =============================
# Config Lib
# =============================
    
config = cfglib.AddonCFG( os.path.join( es.getAddonPath(info.basename), "config.cfg" ) )
config.text("../addons/eventscripts/%s/config.cfg" % info.basename )
config.text("%s Version %s by %s" % ( info.name, info.version, info.author ) )
config.text("For more info, visit: %s" % info.url)
config.text(" ")
config.text("/////////              COUNTER-TERRORISTS            ////////////")
ct_noblock = config.cvar("ct_noblock", 0, "If this is enabled (1) then CTs will get noblock")
ct_blockslash = config.cvar("ct_blockslash", 0, "If this is enabled (1) then the left mouse button of the CTs will be blocked")
config.text(" ")
config.text("/////////                 TERRORISTS                ////////////")
t_noblock = config.cvar("t_noblock", 0, "If this is enabled (1) then Ts will get noblock")
t_flashbangs = config.cvar("t_flashbangs", 2, "How much Flashbangs the Terrorists get at spawn")
t_hegrenade = config.cvar("t_hegrenade", 1, "How much Freezegrenades the Terrorists get at spawn")
t_smokegrenade = config.cvar("t_smokegrenade", 1, "How much Smokegrenades the Terrorists get at spawn")
t_winscore = config.cvar("t_winscore", 2, "How much Score the Terrorists get if they survive a round")
t_noflash = config.cvar("t_noflash", 1, "If the Terrorists shouldnt get flashed")
config.text(" ")
config.text("/////////                   FREEZE GRENADES          ////////////")
freeze_enable = config.cvar("freeze_enable", 1, "If the CT's should get frozen when hit by a HE grenade")
freeze_radius = config.cvar("freeze_radius", 1000, "The radius of the hegrenade [stock settings is 350]")
freeze_damage = config.cvar("freeze_damage", 2, "The damage dealt by the hegrenade [stock settings is 100] (2 means 1 damage, dont ask me why)")
freeze_invulnerable = config.cvar("freeze_invulnerable", 1, "If this is enabled (1) freezed players will get invulnerability(useful with smoke grenades enabled)")
freeze_duration = config.cvar("freeze_duration", 7, "The duration you are frozen by a hegrenade (0 = disable freeze)")
freeze_turning = config.cvar("freeze_turning", 0, "If this is enabled (1) then it will allow players to look freely while frozen")
freeze_effect = config.cvar("freeze_effect", 1, "If this is enabled (1) then it will create an effect on hegrenade explosion")
freeze_trail = config.cvar("freeze_trail", 1, "If this is enabled (1) then will the grenade be followed by a trail")
config.text(" ")
config.text("/////////                   SMOKE GRENADES            ////////////")
smoke_enable = config.cvar("smoke_enable", 1, "If the Smokegrenades should be molotov grenades")
smoke_radius = config.cvar("smoke_radius", 200, "The radius in which the smoke grenade deals damage (0 = disable damage)")
smoke_damage = config.cvar("smoke_damage", 2, "The damage dealt by the smokegrenade (per second)")
smoke_damage = config.cvar("smoke_duration", 10, "How long the fire will burn (in seconds)")
# smoke_damage_enemies_only = config.cvar("smoke_damage_enemies_only", 1, "If this is enabled (1) then the smokegrenades will only cause damage to counter terrorists")
config.text(" ")
config.text("/////////                       MISC                  ////////////")
messagestyle = config.cvar("messagestyle", 2, "The style how start messages should be shown (1 is chat message, 2 is hudhint , 3 is centermessage)")
forceswap = config.cvar("forceswap", 5, "after how much rounds without teamswap a teamswap should take place (0 is disabled)")
spawn_invulnerable = config.cvar("spawn_invulnerable", 1, "If this is enabled (1) then the Counter Terrorists will be invulnerable at spawn")
remove_idle = config.cvar("remove_idle", 0, "If this is enabled (1) then it will remove any weapons dropped")
countdown_length = config.cvar("countdown_length", 10, "How long the black screen for the CTs will last")
real_flashnumber = config.cvar("real_flashnumber", 1, "If this is enabled (1) then it will make the players drop all their grenades on death, not only one")


config.write()
config.execute()

# =============================
# Fixed dict
# =============================

class FixedTypeKeyDictionary(dict):
    def __init__(self, fixed_type=str, *args, **kwargs):
        self._fixed_type = fixed_type
        dict.__init__(self, *args, **kwargs)
        
    def __setitem__(self, key, value):
        dict.__setitem__(self, self._fixed_type(key), value)
        
    def __getitem__(self, key):
        return dict.__getitem__(self, self._fixed_type(key))
        
    def __contains__(self, key):
        return dict.__contains__(self, self._fixed_type(key))


# =============================
# Globals
# =============================
        
classes = FixedTypeKeyDictionary(fixed_type=int)
advertnumber = 0
t_knives = []
ct_knives = []
rounds_without_swap = 0
has_started = 0

# =============================
# Load / unload
# =============================


def load():
    if freeze_enable:
        es.load("hns/freezenade")
    if smoke_enable:
        es.load("hns/molotovnade")
    es.server.queuecmd("mp_restartgame 1")
        

    
def unload():
    if freeze_enable:
        es.unload("hns/freezenade")
    if smoke_enable:
        es.unload("hns/molotovnade")
    
    global classes
    es.doblock('corelib/noisy_off')
    delknives()
    del classes
    gamethread.cancelDelayed("roundtimer")
    gamethread.cancelDelayed("startloop")
    gamethread.cancelDelayed("blockloop")
    
    
# =============================
# Valve events
# =============================
    
def es_map_start(ev):
    classes.clear()
    delknives()
    global has_started
    has_started = 0
    for x in range(1,11):
        es.stringtable('downloadables', 'sound/hns_timer/%ssec.mp3' %x)

        
def player_activate(ev):
    tokens = {"author":info.author}
    tell(ev["userid"], "credits", tokens)

def player_disconnect(ev):
    """ 
    on disconnect remove the player from the dict
    """
    uid = int(ev["userid"])
    if uid in classes:
        del classes[uid]

        
def round_start(ev):
    global advertnumber, has_started
    remove_weapon("#primary", 0)
    remove_weapon("#secondary", 0)
    remove_weapon("#objective", 0)
    
    if advertnumber == 4:
        for x in playerlib.getPlayerList('#all'):
            tell(x, "groupjoin")
    
    if advertnumber == 8:
        tokens = {"author":info.author}
        for x in playerlib.getPlayerList('#all'):
            tell(x, "credits", tokens)
        advertnumber = 0
    
    
    advertnumber += 1
    gamethread.delayedname(0.5, "blockloop", blockknife)
    gamethread.cancelDelayed("roundtimer")
    gamethread.cancelDelayed("startloop")
    gamethread.cancelDelayed("fadeloop")

        
    tokens = {}
    """
    get the correct roundtime in mm:ss
    """
    rndtime = float(es.ServerVar("mp_roundtime"))*60
    minutes, seconds = divmod(int(rndtime), 60)
    tokens["minutes"] = "%s:%02i"% (minutes, seconds)
    for x in playerlib.getPlayerList('#t'):
        tell(x, "hider", tokens)
    for x in playerlib.getPlayerList('#ct'):
        tell(x, "seeker", tokens)
        
        

def round_freeze_end(ev):
    rndtime = float(es.ServerVar("mp_roundtime"))*60
    gtloop(countdown_length)
    fadeLoop(float(countdown_length)-1)
    gamethread.delayedname(rndtime - 10, "roundtimer", timeleft)
    gamethread.delayedname(rndtime - 0.5, "roundtimer", roundend)
    
    if not has_started:
        for x in playerlib.getPlayerList('#ct, #alive'):
            classes[x].setprop( "CBasePlayer.m_fFlags", 64)
            if spawn_invulnerable:
                x.godmode(1)
                x.setColor(255,255,255,125)
    
def item_pickup(ev):
    uid = ev["userid"]
    team = int(ev["es_userteam"])
    if team == 3:
        if ev["item"] != "knife":
            spe.dropWeapon(uid, "weapon_"+ev["item"], False)
    elif team == 2:
        item = ev["item"]
        if uid not in classes:
            return
        if item == "flashbang":
            classes[uid].flashbangs += 1
        elif item == "hegrenade":
            classes[uid].hegrenade += 1
        elif item == "smokegrenade":
            classes[uid].smokegrenade += 1
            
            

def weapon_fire(ev):
    uid = ev['userid']
    team = es.getplayerteam(uid)
    weapon = ev["weapon"]
    if real_flashnumber and team == 2:
        if weapon == "flashbang":
            classes[uid].flashbangs -= 1
        elif weapon == "hegrenade":
            classes[uid].hegrenade -= 1
        elif weapon == "smokegrenade":
            classes[uid].smokegrenade -= 1
        

def player_death(ev):
    uid = ev["userid"]
    if uid in classes:
        if real_flashnumber and es.getplayerteam(uid) == 2:
            classes[uid].dropGrenades()
        classes[uid].removeknife()
    if remove_idle:
        remove_weapon("#all", -1)
    es.setplayerprop(uid, "CBasePlayer.m_fFlags", 0)
    
    
def player_blind(ev):
    if t_noflash:
        uid = ev["userid"]
        if es.getplayerteam(uid) == 2:
            # remove white screen
            es.setplayerprop(uid, "CCSPlayer.m_flFlashMaxAlpha", 0)
    
def round_end(ev):
    global has_started
    global rounds_without_swap
    
    gamethread.delayed(1, delknives)
    gamethread.cancelDelayed("roundtimer")
    gamethread.cancelDelayed("blockloop")
    gamethread.cancelDelayed("starttimer")
    
    has_started = 0
    winner = int(ev["winner"])
    
    if winner == 3:
        rounds_without_swap = 0
        swapTeams()
        for x in es.getUseridList():
            tell(x, "seekerswin")
            
    if winner == 2:
        rounds_without_swap += 1
        for x in playerlib.getPlayerList('#t,#alive'):
            es.server.queuecmd("score add %s %s" % (x, t_winscore))
        for x in es.getUseridList():
            tell(x, "hiderswin")
            
        if rounds_without_swap == forceswap:
            tokens = {}
            tokens["rounds"] = forceswap
            swapTeams()
            for x in es.getUseridList():
                tell(x, "forceswap", tokens)
        
    delknives()
    classes.clear()
    

def player_spawn(ev):
    uid = ev["userid"]
    if not es.getuserid(uid): return
    if es.getplayerprop(uid, 'CBasePlayer.pl.deadflag'): return
    classes[uid] = Spieler(uid)
    es.server.queuecmd("es_xfire %s func_buyzone kill"% uid)
    es.server.queuecmd("es_xfire %s weapon_c4 kill"% uid)
    es.server.queuecmd("es_xfire %s weapon_usp kill"% uid)
    es.server.queuecmd("es_xfire %s weapon_glock kill"% uid)
    es.server.queuecmd("es_xfire %s hostage_entity kill"% uid)
    

    
# =============================
# Own Functions
# =============================
    
def timeleft():
    for x in es.getUseridList():
        tell(x, "tenseconds")
    
def roundend():
    for x in playerlib.getPlayerList('#ct,#alive'):
        classes[x].slayplayer()
    
def gtloop(num):
    num = int(num)
    if num == 0:
        global has_started
        es.emitsound('player', es.getuserid(), "radio/go.wav", 1, 0) 
        for x in es.getUseridList():
            usermsg.hudhint(x, " ")

            if es.getplayerteam(x) == 3: 
                message = "gogogo"
            else: 
                message = "seekingstarted"
            tell(x,message)
            if es.getplayerprop(x, 'CBasePlayer.pl.deadflag'): continue
            es.setplayerprop(x, "CBasePlayer.m_fFlags", 1)
            if spawn_invulnerable:
                playerlib.getPlayer(x).godmode(0)
                playerlib.getPlayer(x).setColor(255,255,255,255)
            # classes[x].unfadeStart()
        has_started = 1
        return
        
    if num < 11:
        es.emitsound('player', es.getuserid(), "hns_timer/%ssec.mp3" % num, 1, 0) 
    tokens = {}
    tokens["seconds"] = str(num)
    for x in es.getUseridList():
        tell(x, "countdown", tokens, typeofmessage = messagestyle)
    # for x in playerlib.getPlayerList('#ct,#alive'):
    #     es.setplayerprop(x, "CBasePlayer.m_fFlags", 32)
    #     if spawn_invulnerable:
    #         x.godmode(0)
    #         x.setColor(255,255,255,255)
    num -= 1
    if num > -1:
        gamethread.delayedname(1,"startloop", gtloop, (num,))
    

def delknives():
    global t_knives, ct_knives
    t_knives = []
    ct_knives = []

def remove_weapon(weptype, playerhandle = -1):
    """
    remove the weapon type "weptype", 
    if playerhandle = -1 then only remove idling weapons
    else remove the weapons by this player only 
    if playerhandle = 0 remove every weapon of that type
    """
    # handle = es.getplayerhandle(player)
    for weapon in weaponlib.getWeaponList(weptype):
        if str(weapon) == "weapon_knife":
            continue
        for index in weapon.indexlist:
            if playerhandle != 0:
                if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == playerhandle:
                    if not spe.removeEntityByIndex(index): es.dbgmsg(0,"TRIED TO REMOVE INVALID ENT ID: %s" % index)
            else:
                if not spe.removeEntityByIndex(index): es.dbgmsg(0,"TRIED TO REMOVE INVALID ENT ID: %s" % index)
                # es.server.queuecmd('es_xremove %s' % index)
            
            
def fadeLoop(timeleft):
    if timeleft > 0:
        for x in playerlib.getPlayerList('#ct,#alive'):
            usermsg.fade(x, 2, 1, 100, 0, 0, 0, 255)
        timeleft = timeleft - 0.1
        gamethread.cancelDelayed("fadeloop")
        gamethread.delayedname(0.1, "fadeloop", fadeLoop, timeleft)

def blockknife():
    for x in t_knives:
        es.setindexprop(x, 'CBaseCombatWeapon.LocalActiveWeaponData.m_flNextPrimaryAttack', 9999999)
        es.setindexprop(x, 'CBaseCombatWeapon.LocalActiveWeaponData.m_flNextSecondaryAttack', 9999999)
    if ct_blockslash:
        for x in ct_knives:
            es.setindexprop(x, 'CBaseCombatWeapon.LocalActiveWeaponData.m_flNextPrimaryAttack', 9999999)
    gamethread.delayedname(0.8, "blockloop", blockknife)
    
def newgive(uid, weaponname):
    loc = es.getplayerprop(uid, "CBaseEntity.m_vecOrigin").replace(","," ")
    ind = es.createentity(weaponname, "abd")
    es.entitysetvalue(ind,"origin",loc)
    es.spawnentity(ind)

    
def tell(uid, message, options = {}, tellMessage = True, typeofmessage = 1):
    """
    Just a simple wrapper to send a multi language text or return it if tellMessage is False 
    """
    message = text(message, options, playerlib.getPlayer(uid).get("lang") )
    if typeofmessage == 1:
        if tellMessage:
            es.tell(uid, '#multi', '#lightgreen[HideNSeek] #green%s' % message)
        else:
            return message
    elif typeofmessage == 2:
        usermsg.hudhint(uid, message)
    elif typeofmessage == 3:
        usermsg.centermsg(uid, message)
    
def swapTeams():
    for x in es.getUseridList():
        if es.getplayerteam(x) in (2,3):
            spe.switchTeam(x, 5 - es.getplayerteam(x))

    
# =============================
# Classes
# =============================
    
class Spieler(object):
    def __init__(self, uid):
        self.uid = int(uid)
        self.libplayer = playerlib.getPlayer(uid)
        
        self.team = es.getplayerteam(self.uid)
        
        self.stripplayer()
        # self.fadeplayer(0, 1, 0, 0, 0, 0, 0)
        if self.team == 3:

            if ct_noblock:
                self.setprop("CCSPlayer.m_CollisionGroup", 2)
            if not has_started:
                self.setprop( "CBasePlayer.m_fFlags", 64)
                if spawn_invulnerable:
                    self.libplayer.godmode(1)
                    self.libplayer.setColor(255,255,255,125)
        
        elif self.team == 2:
            if t_noblock:
                self.setprop("CCSPlayer.m_CollisionGroup", 2)
            gamethread.delayed(0,self.equipT)
            gamethread.delayed(0.5,self.setprop,("CBasePlayer.m_fFlags", 1))
            
            self.setcolor()
            self.flashbangs = 0
            self.hegrenade = 0
            self.smokegrenade = 0
        
        es.server.queuecmd("es_sexec %s use weapon_knife" % self.uid)
        gamethread.delayed(0.1, self.getKnives)

        
    def getKnives(self):
        self.knife = self.getknife
        if self.team == 3:
            if ct_blockslash:
                ct_knives.append(self.knife)
        elif self.team == 2:
            t_knives.append(self.knife)
        
    def equipT(self):
        if t_flashbangs:
            gamethread.delayed(0, self.give, ('weapon_flashbang')) #crashes
            # newgive(self.uid,'weapon_flashbang')
            gamethread.delayed(0.1, self.setprop, ("CCSPlayer.baseclass.localdata.m_iAmmo.012", t_flashbangs))
            gamethread.delayed(0.1, setattr, (self, "flashbangs", int(t_flashbangs)))
            
        if t_hegrenade:
            gamethread.delayed(0, self.give, ('weapon_hegrenade'))
            # newgive(self.uid,'weapon_hegrenade')
            gamethread.delayed(0.1, self.setprop, ("CCSPlayer.baseclass.localdata.m_iAmmo.011", t_hegrenade))
            gamethread.delayed(0.1, setattr, (self, "hegrenade", int(t_hegrenade)))
        
        if t_smokegrenade:
            gamethread.delayed(0, self.give, ('weapon_smokegrenade'))
            # newgive(self.uid,'weapon_smokegrenade')
            gamethread.delayed(0.1, self.setprop, ("CCSPlayer.baseclass.localdata.m_iAmmo.013", t_smokegrenade))
            gamethread.delayed(0.1, setattr, (self, "smokegrenade", int(t_smokegrenade)))
        

        
    @property
    def getknife(self):
        dict_entity_list = es.createentityindexlist('weapon_knife')
        str_player_handle = es.getplayerhandle(self.uid)

        for int_index in dict_entity_list:
            if str_player_handle == es.getindexprop(int_index, 'CBaseEntity.m_hOwnerEntity'):
                return int_index
    
    def removeknife(self):
        knifeindex = self.knife
        if self.team == 2:
            if knifeindex in t_knives:
                t_knives.remove(knifeindex)
        else:
            if ct_blockslash:
                if knifeindex in ct_knives:
                    ct_knives.remove(knifeindex)
    
    def stripplayer(self):
        remove_weapon("#all",es.getplayerhandle(self.uid))
        
    def setprop(self, prop, value):
        es.setplayerprop(self.uid, prop, value)

    def give(self, item):
        es.server.queuecmd('es_xgive %s %s' % (self.uid, item))
        
    def setcolor(self, R = 255, G = 255, B = 255, alpha = None):
        self.libplayer.setColor(R,G,B,alpha)
        
    def playplayer(self, soundname, volume = 1, attenuation = 0.5):
        es.emitsound('player', self.uid, soundname, volume, attenuation) 
        
    # def unfadeStart(self):
        # if self.team == 3:
            # self.fadeplayer(1, 100, 1, 0, 0, 0, 255)
        
    def fadeplayer(self, type, time, holdtime, r, g, b, a):
        """ 
        time and holdtimes are measured in frames (maybe tickrate)
        type = <0 = no fade, 1 = fade out, 2 = fade in>
        """
        usermsg.fade(self.uid, type, time, holdtime, r, g, b, a)
        
    def slayplayer(self):
        self.libplayer.slay()
            
    def dropGrenades(self):
        """
        you first drop HE (if you have one) then drop flash
        and then drop smoke
        """
        if self.hegrenade > 0:
            self.hegrenade -= 1
        elif self.flashbangs > 0:
            self.flashbangs -= 1
        elif self.smokegrenade > 0:
            self.smokegrenade -= 1
        else:
            return
            
        for x in ((self.hegrenade, "hegrenade"), (self.flashbangs, "flashbang"), (self.smokegrenade, "smokegrenade")):
            if x[0] > 0:
                for y in range(x[0]):
                    index = es.createentity("weapon_"+x[1])
                    es.entitysetvalue(index,"origin", " ".join(map(lambda x: str(x),es.getplayerlocation(self.uid))))
                    es.spawnentity(index)

